;Przykładowy program POOL, możesz go używać,
;modyfikować i rozpowszechniać na licencji GPL.
;Autorzy: R&D Independent Team
;Źródło: www.pool-rnd.pl

window ht
setbg "black
shared [nr hold size rads]
"hold := false
"nr := 3 ;tu możesz dodać więcej promieni...

to slider_change
  let "state :hold
  if not :hold ["hold := true waitsignal "stop]
  update_params @ :p
  "hold := :state
  go @ :p
end

"size := (slider "size {8 40 120} {10 200 1} 50)
setonchange :size $slider_change

"rads := newarray :nr
repeat :nr [
  :rads,repcount := (slider
  word "r_ repcount
  (array 8 40*repcount + 45 120)
  (array 0 200 1)
  random 200)
  setonchange :rads,repcount $slider_change
]

to painter
to hypotrochoid :d :radii :t :xy
    :xy,1 := 0 :xy,2 := 0
    let "cos_t radcos :t
    let "sin_t radsin :t
    repeat (count :radii) - 1 [
      let "b :radii,(repcount + 1)
      let "a :radii,repcount - :b
      let "c :a / :b * :t
      :xy,1 += :a * :cos_t
      :xy,2 += :a * :sin_t
      "cos_t := radcos :c
      "sin_t := radsin :c
    ]
    :xy,1 += :d * :cos_t
    :xy,2 -= :d * :sin_t
    output :xy
  end

  let "h 0
  let "rval newarray count :rads
  to update_params
    repeat count :rads [:rval,repcount := getvalue :rads,repcount]
    "h := getvalue :size
  end

  let "xy_i {0 0}
  to draw
    "t := timenow
    repeat count :rval [
      :rval,repcount += 0.0025 * radsin 0.0001 * (:t - repcount * 5000) * radsin repcount / 1.3
      "h += 0.025 * radsin 0.00008 * (:t + 5000)
    ]
    clean
    pu setpos hypotrochoid :h :rval 0 :xy_i pd
    for [i 0 40000 2.5] [
      setpos hypotrochoid :h :rval (:i * m_pi / 200) :xy_i
    ]
    refresh
  end

  to go while not :hold [draw] signal "stop end

  setpc {90 100 94 15}
end

:pool_cfg,"refresh := false
"p := (newt $painter)
update_params @ :p
go @ :p

"bhold := (button "Zatrzymaj [8 8 120 24] [
  "hold := not :hold
  ifelse :hold [settext :bhold "Rysuj]
  [go @ :p settext :bhold "Zatrzymaj]
])



